/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_objects.h"
#include  "mtk_solar_system.h"
#include  "mtk_spacecraft.h"
#include  "mtk_stars_2.h"
#include  "mtk_nearby_galaxies.h"
#include  "mtk_label.h"
#include  "mtk_fixed_object.h"
#include  <vector>
#include  <map>
#include  <string>
#include  <algorithm>

#include  "mtk_stars.h"
#include  "mtk_minor_planets.h"





//---------------
//  z_list_elem
//---------------
class z_list_elem
{
public:
	int		idx;	// idx
	float	z;		// z-l

	bool operator<(const z_list_elem& zl) const  { return z < zl.z; }
};




//---  SIuWFNg̃xN^  ---
static std::vector<mtk_object>	vObject;

//---  IuWFNgp̃L[  ---
static std::map<std::string, int>  vObjectKey;



//---  \pXg ---
static std::vector<z_list_elem>	vZ_near, vZ_far;
static int num_near, num_far;

//---  IpXg  ---
static std::vector<z_list_elem>	vZ_tgt;
static int num_tgt;

static int selected_object_index = -1;
static int hit_mx, hit_my;




//--------
//  init
//--------
void
clear_objects()
{
	vObject.clear();
	vObjectKey.clear();

	vZ_near.clear();
	vZ_far.clear();
	vZ_tgt.clear();
}


int
register_object(const mtk_object& obj, const char* key)
{
	vObject.push_back(obj);

	int ID;
	ID = vObject.size() - 1;

	vObjectKey[key] = ID;

	return ID;
}



//-------
//  Get
//-------
const mtk_object&
get_object(int idx)
{
	return  vObject[idx];
}


int
get_object_ID(const char* key)
{
	std::map<std::string, int>::iterator  it = vObjectKey.find( std::string(key) );
	if (it == vObjectKey.end())  return  -1;
	return  it->second;
}


const mtk_object&
get_object(const char* key)
{
	int ID = get_object_ID(key);

	//********** Error  **********//
	if (ID == -1)  return  vObject[0];

	return  vObject[ID];
}



//-------------------
//  Selected object
//-------------------
bool
is_there_selected_object()
{
	return  (selected_object_index != -1);
}

int
get_selected_object_ID()
{
	return  selected_object_index;
}

const mtk_object&
get_selected_object()
{
	if (selected_object_index == -1) {
		return  vObject[0];	//***** Error *****
	}

	return  vObject[ selected_object_index ];
}

void
reset_selected_object()
{
	selected_object_index = -1;
}


void
get_object_hit_pos(int* pmx, int* pmy)
{
	*pmx = hit_mx;
	*pmy = hit_my;
}



//--------
//  Draw
//--------
void
prepare_draw_objects(mtk_draw_struct* v_ds, int Nds)
{
	const int N = vObject.size();
	const float z_near = get_z_near();
	const float z_mid  = get_z_mid();
	const float z_far  = get_z_far();

	const mtk_draw_struct& ds = v_ds[0];



	vector3f  eRf, eUf;
	eRf = ds.eRf;
	eUf = ds.eUf;
	//***
	const vector3d  cpos = ds.camera_base.get_pos();
	//***



	//---------------
	//  Init z-list
	//---------------
	num_near = num_far = num_tgt = 0;

	if (vZ_near.size() < N) {
		vZ_near.resize(N);
	}
	if (vZ_far.size() < N) {
		vZ_far.resize(N);
	}
	if (vZ_tgt.size() < N) {
		vZ_tgt.resize(N);
	}



	//-----------------------
	//  Prepare for culling
	//-----------------------
	vector3d nv[8];
	for (int j = 0; j < Nds; j++) {
		const mtk_draw_struct& _ds = v_ds[j];
		frustum  frs = _ds.get_frustum();

		frs.calc_cull_vectors(&nv[j * 4]);
	}
	


	//-----------------------------------
	//  Register objects to the z_lists
	//-----------------------------------
	prepare_draw_stars_2(ds);

	for (int i = 0; i<N; i++) {
		mtk_object& obj = vObject[i];

		int  draw_rgn = obj.prepare_draw(v_ds, nv, Nds, z_near, z_mid, z_far);

		if (draw_rgn == OBJ_DRAW_NONE)  continue;

		float z = obj.get_draw_z() + obj.get_dz();

		//--  Near region
		if (draw_rgn == OBJ_DRAW_NEAR || draw_rgn == OBJ_DRAW_BOTH) {
			vZ_near[num_near].idx = i;
			vZ_near[num_near].z   = z;
			num_near++;
		}

		//--  Far region
		if (draw_rgn == OBJ_DRAW_FAR || draw_rgn == OBJ_DRAW_BOTH) {
			vZ_far[num_far].idx = i;
			vZ_far[num_far].z   = z;
			num_far++;
		}

		//--  Target list
		if ( obj.get_hit_test_status() != OBJ_HITTEST_STAT_NONE ) {
			vZ_tgt[num_tgt].idx = i;
			vZ_tgt[num_tgt].z   = z;
			num_tgt++;
		}



	
		//--  pre calc billboard orientation
		if (!ds.bRotateBillboard) {
			continue;
		}


		int obj_ty = obj.get_type();
		if (obj_ty != OBJ_TYPE_STAR && obj_ty != OBJ_TYPE_SMALL_OBJECT && obj_ty != OBJ_TYPE_NEARBY_GALAXY) {
			continue;
		}



		int obj_idx = obj.get_index();
		vector3d rpos = obj.get_pos() - cpos;

		// x[XJr{[h
		vector3f  eF2, eU2, eR2;
		eF2 = normalize(rpos);
		eR2 = normalize(cross_product(eF2, eUf));
		eU2 = cross_product(eR2, eF2);


		if (obj_ty == OBJ_TYPE_STAR) {
			mtk_star&  st = get_star(obj_idx);

			st.eR = eR2;
			st.eU = eU2;
		}
		else if (obj_ty == OBJ_TYPE_SMALL_OBJECT) {
			small_object&  sm = get_small_object(obj_idx);

			sm.eR = eR2;
			sm.eU = eU2;
		}
		else if (obj_ty == OBJ_TYPE_NEARBY_GALAXY) {
			nearby_galaxy2& ng = get_nearby_galaxy(obj_idx);

			ng.eR = eR2;
			ng.eU = eU2;
		}
		
	}

	//---  z-sort  ---
	std::sort(vZ_near.begin(), vZ_near.begin() + num_near);
	std::sort(vZ_far.begin(),  vZ_far.begin()  + num_far);
	std::sort(vZ_tgt.begin(), vZ_tgt.begin() + num_tgt);

	{
		char str[256];
		sprintf(str, "near=%d  far=%d  tgt=%d\n", num_near, num_far, num_tgt);
		OutputDebugString(str);
	}
}





int
get_draw_object_num_near()
{
	return  num_near;
}

int
get_draw_object_num_far()
{
	return  num_far;
}

int
get_target_object_num()
{
	return  num_tgt;
}




//--------
//  Draw
//--------
void
draw_objects(const mtk_draw_struct& ds, bool bNear)
{
	const std::vector<z_list_elem>&  zl = (bNear)  ?  vZ_near  :  vZ_far;
	const int num  =  (bNear)  ?  num_near  :  num_far;

	glPushAttrib(GL_ALL_ATTRIB_BITS);


	//---  `悷  ---
	int obj_ty_prev = -1;
	int draw_stat_prev = -1;
	for (int i=num-1; i>=0; i--) {
		int idx = zl[i].idx;
		bool flg = (idx == selected_object_index);

		int obj_ty = vObject[idx].get_type();
		int draw_stat = vObject[idx].get_draw_status();

		bool bChange = ((obj_ty_prev != obj_ty) || (draw_stat_prev != draw_stat));
		vObject[idx].draw(ds, flg, bChange);
		
		obj_ty_prev = obj_ty;
		draw_stat_prev = draw_stat;
	}


	glPopAttrib();

	glDisable(GL_TEXTURE_2D);
}




//-------------
//  Hit test
//-------------
bool
hit_test_objects(const mtk_draw_struct& ds, int mx, int my)
{
	int  num, ix, iy;
	int sel_obj_idx_old = selected_object_index;
	selected_object_index = -1;

	hit_mx = mx;
	hit_my = my;



	//--  J̕xNg𓾂
	vector3d  eF, eU, eR;

	
	ds.camera.get_axes(eF, eU, eR);
	
	
	//--  x,y ̕xNg
	const frustum frs = ds.get_frustum();
	const float x1 = frs.get_x1();
	const float x2 = frs.get_x2();
	const float y1 = frs.get_y1();
	const float y2 = frs.get_y2();
	const float z1 = frs.get_z1();
	const float sclx = (x2 - x1) / ds.vp_w;
	const float scly = (y2 - y1) / ds.vp_h;
	const float xx = sclx*float(mx - ds.vp_x1) + x1;
	const float yy = scly*float(my - ds.vp_y1) + y1;
	const vector3d n0 = normalize(vector3d(xx, yy, -z1));	// _Wnł̕xNg
	//--  Wnł̕xNg
	const vector3d n = n0.x*eR + n0.y*eU - n0.z*eF;
	const vector3d  cpos = ds.camera_base.get_pos();

	for (int i=0; i<num_tgt; i++) {
		int idx = vZ_tgt[i].idx;
		mtk_object&  obj = vObject[idx];
		if ( obj.hit_test(ds, mx, my, cpos, n) ) {
			//---  hit  ---

			//*******
			if (obj.get_type() == OBJ_TYPE_LABEL) {
				idx = get_label_parent_object_index( obj.get_index() );
			}
			if (get_object(idx).get_type() == OBJ_TYPE_FIXED_OBJECT) {
				if (get_fixed_object_type( get_object(idx).get_index() ) == OBJ_TYPE_OUR_GALAXY) {
					idx = get_object_ID("OurGalaxy");
				}
			}
			//*******

			selected_object_index = idx;
			return  true;
		}
	}


	return  (selected_object_index != sel_obj_idx_old);
}

